<?php

define('SKIP_KOHANA', true);
require('/opt/monitor/op5/ninja/index.php');

require_once('classes/common_gui.php');
# safety catch. If we don't do this up top, we'll produce some
# wonky output later on when we try to calculate and include the
# correct object class
if (!$input->obj_type || (!$input->obj_id && !$input->master_obj_id)) {
	$page->html_end();
}

require_once('include/clone.inc.php');

$clone_targets = false;
$vars_to_clone = array();
$sub_objs_to_clone = array();
$bad_mojo = false;

$page->html_start();
nacoma_objlock::die_if_locked_hard();

$vars_to_clone = $input->get_array('obj_vars');
if ($vars_to_clone)
  $vars_to_clone = array_keys($vars_to_clone);
$sub_objs_to_clone = $input->get_array('sub_obj');
$clone_detail = $input->get_array('clone_detail');

$obj_nacoma_Model = $input->obj_type . '_nacoma_Model';
$obj = new $obj_nacoma_Model($input->obj_id);

$page->form_start();
$page->hidden_var('obj_type', $obj->type);
if ($input->obj_id)
  $page->hidden_var('obj_id', $obj->id);
if ($input->master_obj_id)
  $page->hidden_var('master_obj_id', $input->master_obj_id);

if (!empty($_REQUEST['clone_targets']))
{
	$clone_targets = $_REQUEST['clone_targets'];

	if ($obj->type === 'service') {
		if (!is_array($clone_targets)) {
			echo "Youse fail!<br />\n";
			$bad_mojo = true;
		}
	}
	elseif ($obj->type === 'host') {
		if (is_numeric($clone_targets)) {
			$clone_targets = intval($clone_targets);
			$step = 2;
		}
		else {
			echo "Number of clones must be a numeric value (doh!)<br />\n";
			$bad_mojo = true;
		}
	}
}

/**
 * Create the cloned services and assign them to the
 * selected hosts.
 */
function multi_service_clone_step2($sub_objs)
{
	global $input, $DEBUG, $page;

	if (empty($input->selection)) {
		echo "No hosts selected to clone services to<br />\n";
		return;
	}

	if (!$sub_objs || empty($sub_objs['service'])) {
		echo "no services selected to clone.<br />\n";
		return;
	}

	$srv_list = $sub_objs['service'];
	foreach ($sub_objs['service'] as $id => $ary) {
		if (empty($ary['service']) || $ary['service'] !== 'on') {
			unset($srv_list[$id]);
			continue;
		}

		# since we're dealing with services, and the service
		# itself is included is included in its own sub_objects
		# list, we need to make sure it has any other objects
		# before we call 'load_sub_objects()', otherwise we'll
		# get mysql errors when it tries to find itself as a
		# sub-object.
		if (count($ary) > 1) {
			unset($ary['service']);
			$obj->sub_objects = load_sub_objects($obj, $ary);
		}

		$obj_list[$obj->id] = $obj;
	}

	# This is the luxury variant of cloning. We don't
	# actually have to create the clones. Instead we
	# just update the master object id and reset
	# the object ids for each iteration
	foreach (array_pop($input->selection) as $host_id) {
		foreach ($obj_list as $id => $obj) {
			$result = save_object_chain($obj, $host_id);
			if ($result !== true) {
				echo "Failed to save $obj->type object {$obj->get_object_name()}";
				if ($DEBUG) { echo "<pre>\n"; print_r($result); echo "</pre>\n"; }
			}
		}
	}
}

# clone multiple services
if (!empty($input->master_obj_id) && empty($sub_objs_to_clone)) {
	$obj = new host_nacoma_Model($input->master_obj_id);
	host_clone_create_service_list($obj);
	$page->make_multi_host_selection();
	$page->submit_button('Clone services');
}
elseif (!$input->obj_type && !$input->obj_id) {
	# bail out noisily
	echo "Youse fail!<br />\n";
	$input->debug_print();
	$page->html_end();
}
else switch ($input->action) {
 case 'Create host clones':
	host_clone_step_3($obj, $clone_detail, $sub_objs_to_clone);
	break;

 case 'Clone':
	if ($obj->type === 'service')
	  service_clone_step_2($obj, $sub_objs_to_clone);
	elseif ($obj->type === 'host')
	  host_clone_step_2($obj, $clone_targets, $vars_to_clone, $sub_objs_to_clone);
	else
		clone_slave_object($obj);
	break;

 case 'Clone services':
	multi_service_clone_step2($sub_objs_to_clone);
	break;
 default:
	clone_step_1($obj);
	break;
}

$page->form_end();
echo '</div>';
$page->html_end();
