<?php
/**
 * file: delete.php
 *
 * Handle delete requests for various objects
 */

define('SKIP_KOHANA', true);
require('/opt/monitor/op5/ninja/index.php');

require_once('classes/common_gui.php');

if (!$input->obj_type) {
	require_once('index.php');
	exit(0);
}

$page->html_start();

nacoma_objlock::die_if_locked_hard();

# make sure the passed object type is actually supported
# (that is, there is a class and a class-file for it)
$class_name = $input->obj_type . '_nacoma_Model';
if (in_array($input->obj_type, $input->protected) || !(class_exists($class_name) && is_subclass_of($class_name, 'object_nacoma_Model'))) {
	echo "$input->obj_type is not a supported object type<br />";
	$page->html_end();
	exit(0);
}

#####
if ($DEBUG){
	$input->debug_print();
}


$obj = new $class_name($input->obj_id);
if ($input->master_obj_id)
  $obj->master_obj_id = $input->master_obj_id;

$res = false;

switch ( strtolower($input->action) ) {
	case 'delete':
	$res = $obj->delete_object();
	break;

	case 'force_delete':
	$res = $obj->banish_object();
	break;

}

$page->print_message($obj->get_deletion_message());

// provide back link
echo "</div><div class='magic max'>";
if ($obj->master_obj_id){
	$href = "edit.php?obj_type=".$obj->type."&amp;master_obj_id=".$obj->master_obj_id;
	if($obj->master_obj_type) {
		$href .= "&amp;master_obj_type=".$obj->master_obj_type;
	}
	echo "<a href='$href'>back</a>";
} else {
	echo "<a href=\"edit.php?obj_type=".$obj->type."&amp;list=true\">back</a>";
}
echo "</div><div>";

if ($res)
	echo top_bar_nacoma_Model::add_unsaved_warning();

$page->html_end();
