<?php

$days_per_month = array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
$valid_weekdays = array('sunday','monday','tuesday','wednesday','thursday','friday','saturday');
$valid_months = array
(
	1  => 'January',
	2  => 'February',
	3  => 'March',
	4  => 'April',
	5  => 'May',
	6  => 'June',
	7  => 'July',
	8  => 'August',
	9  => 'September',
	10 => 'October',
	11 => 'November',
	12 => 'December'
);

$weekday_offsets = array
(
	1 => 'first',
	2 => 'second',
	3 => 'third',
	4 => 'fourth',
	-1 => 'last',
	-2 => 'second to last',
);

function timeperiod_exceptions_print(timeperiod_nacoma_Model &$obj, gui_nacoma_Model &$gui)
{
	global $valid_months, $valid_weekdays, $days_per_month, $weekday_offsets;
	$end_dates = array
	(
		-1 => 'Last day',
		-2 => '2nd to last day',
		-3 => '3rd to last day',
		-4 => '4th to last day',
		-5 => '5th to last day',
	);

	$existing_exceptions = '';
	if(!empty($obj->custom_vars))
	{
		foreach ($obj->custom_vars as $dateranges => $timeranges) {

			$value = str_replace('"', '$quot;', $dateranges);
			$hours = str_replace('"', '&quot;', $timeranges);
			$text = "$value ($hours)";

			$existing_exceptions .= "<option value='$value' attr_hours='$hours'>$text</option>\n";
		}
	}

	?>
	<tr>
		<td class="HelpList" colspan="2">
			<a href="#" title="Click to view help on timeperiod exception methods" tabindex="-1" data-help='timeperiod_method'><img src="images/icons/shield-help.png" alt="Help" title="Help" /></a>
		</td>
		<td class="VarList">Guided or manual</td>
		<td>
			<input type="radio" name="exc_method" id="exc_simple" checked="checked" /><label for="exc_simple">Guided</label>
			<input type="radio" name="exc_method" id="exc_advanced" /><label for="exc_advanced">Manual</label>
		</td>
	</tr>
	<tr class="simple">
		<td class="HelpList" colspan="2">
			<a href="#" title="Click to view help on exception type" tabindex='-1' data-help='exception_type'><img src="images/icons/shield-help.png" alt="Help" title="Help" /></a>
		</td>
		<td class="VarList">Exception type</td>
		<td>
			<input type="radio" name="exc_t" id="exc_date" checked="checked" /> <label for="exc_date">Date</label>
			<input type="radio" name="exc_t" id="exc_day" /> <label for="exc_day">Day</label>
		</td>
	</tr>
	<tr class="date_rows simple">
		<td class="HelpList" colspan="2">
			<a href="#" title="Click to view help on date interval" tabindex='-1' data-help='date_single_range'><img src="images/icons/shield-help.png" alt="Help" title="Help" /></a>
		</td>
		<td class="VarList">Interval</td>
		<td>
			<input type="radio" name="exc_r" id="exc_single_date" checked="checked" /> <label for="exc_single_date">Single date</label>
			<input type="radio" name="exc_r" id="exc_date_range" /> <label for="exc_date_range">Date range</label>
		</td>
	</tr>
	<tr class="day_rows simple">
		<td class="HelpList" colspan="2">
			<a href="#" title="Click to view help on day interval" tabindex='-1' data-help='day_single_range'><img src="images/icons/shield-help.png" alt="Help" title="Help" /></a>
		</td>
		<td class="VarList">Interval</td>
		<td>
			<input type="radio" name="exc_day_interv" id="exc_single_day" checked="checked" /> <label for="exc_single_day">Single day</label>
			<input type="radio" name="exc_day_interv" id="exc_day_range" /> <label for="exc_day_range">Day range</label>
		</td>
	</tr>
	<tr class="date_single_rows simple">
		<td class="HelpList" colspan="2">
			<a href="#" title="Click to view help on single date" tabindex='-1' data-help='date_single'><img src="images/icons/shield-help.png" alt="Help" title="Help" /></a>
		</td>
		<td class="VarList">Date</td>
		<td>
			<select class="small first" id="date_single_year">
				<option value=''>Every year</option>
				<?php for($i=date("Y")-5;$i<=date("Y")+5; $i++) printf("<option value='%d'>%d</option>", $i, $i); ?>
			</select>
			<select class="small second" id="date_single_month">
				<option value=''>Every month</option>
				<?php for($i=1;$i<=12; $i++) printf("<option value='%d'>%s</option>", $i, $valid_months[$i]); ?>
			</select>
			<select class="tiny third" id="date_single_day">
				<option value=''>Every day</option>
				<?php for($i=1;$i<=31; $i++) printf("<option value='%d'>%02d</option>", $i, $i); ?>
				<?php for($i=-1;$i>=-5; $i--) printf("<option value='%d'>%s</option>", $i, $end_dates[$i]); ?>
			</select>
		</td>
	</tr>
	<tr class="date_range_rows simple">
		<td class="HelpList" colspan="2">
			<a href="#" title="Click to view help on from date" tabindex='-1' data-help='date_from'><img src="images/icons/shield-help.png" alt="Help" title="Help" /></a>
		</td>
		<td class="VarList">From date</td>
		<td>
			<select class="small first" id="date_from_year">
				<option value=''>Every year</option>
				<?php for($i=date("Y")-5;$i<=date("Y")+5; $i++) printf("<option value='%d'>%d</option>", $i, $i); ?>
			</select>
			<select class="small second" id="date_from_month">
				<option value=''>Every month</option>
				<?php for($i=1;$i<=12; $i++) printf("<option value='%d'>%s</option>", $i, $valid_months[$i]); ?>
			</select>
			<select class="tiny third" id="date_from_day">
				<option value=''>Every day</option>
				<?php for($i=1;$i<=31; $i++) printf("<option value='%d'>%02d</option>", $i, $i); ?>
				<?php for($i=-1;$i>=-5; $i--) printf("<option value='%d'>%s</option>", $i, $end_dates[$i]); ?>
			</select>

		</td>
	</tr>
	<tr class="date_range_rows simple">
		<td class="HelpList" colspan="2">
			<a href="#" title="Click to view help on to date" tabindex='-1' data-help='date_to'><img src="images/icons/shield-help.png" alt="Help" title="Help" /></a>
		</td>
		<td class="VarList"> To date</td>
		<td>
			<select class="small first" id="date_to_year">
				<option value=''>Every year</option>
				<?php for($i=date("Y")-5;$i<=date("Y")+5; $i++) printf("<option value='%d'>%d</option>", $i, $i); ?>
			</select>
			<select class="small second" id="date_to_month">
				<option value=''>Every month</option>
				<?php for($i=1;$i<=12; $i++) printf("<option value='%d'>%s</option>", $i, $valid_months[$i]); ?>
			</select>
			<select class="tiny third" id="date_to_day">
				<option value=''>Every day</option>
				<?php for($i=1;$i<=31; $i++) printf("<option value='%d'>%02d</option>", $i, $i); ?>
				<?php for($i=-1;$i>=-5; $i--) printf("<option value='%d'>%s</option>", $i, $end_dates[$i]); ?>
			</select>
		</td>
	</tr>
	<tr class="day_single_rows simple">
		<td class="HelpList" colspan="2">
			<a href="#" title="Click to view help on single day" tabindex='-1' data-help='day_single'><img src="images/icons/shield-help.png" alt="Help" title="Help" /></a>
		</td>
		<td class="VarList"> Weekday</td>
		<td>
			<select id="single_weekday_offset">
				<?php foreach($weekday_offsets as $i=>$o) printf("<option value='%d'>%s</option>", $i, $o) ?>
			</select>
			<select id="single_weekday_name">
				<?php foreach($valid_weekdays as $i=>$d) printf("<option value='%d'>%s</option>", $i, $d) ?>
			</select>
			<select id="single_weekday_month">
				<option value=''>Every month</option>
				<?php foreach($valid_months as $i=>$m) printf("<option value='%d'>%s</option>", $i, $m) ?>
			</select>
		</td>
	</tr>
	<tr class="day_range_rows simple">
		<td class="HelpList" colspan="2">
			<a href="#" title="Click to view help on from weekday" tabindex='-1' data-help='day_from'><img src="images/icons/shield-help.png" alt="Help" title="Help" /></a>
		</td>
		<td class="VarList"> From weekday</td>
		<td>
			<select id="from_weekday_offset">
				<?php foreach($weekday_offsets as $i=>$o) printf("<option value='%d'>%s</option>", $i, $o) ?>
			</select>
			<select id="from_weekday_name">
				<?php foreach($valid_weekdays as $i=>$d) printf("<option value='%d'>%s</option>", $i, $d) ?>
			</select>
			<select id="from_weekday_month">
				<option value=''>Every month</option>
				<?php foreach($valid_months as $i=>$m) printf("<option value='%d'>%s</option>", $i, $m) ?>
			</select>
		</td>
	</tr>
	<tr class="day_range_rows simple">
		<td class="HelpList" colspan="2">
			<a href="#" title="Click to view help on to weekday" tabindex='-1' data-help='day_to'><img src="images/icons/shield-help.png" alt="Help" title="Help" /></a>
		</td>
		<td class="VarList"> To weekday</td>
		<td>
			<select id="to_weekday_offset">
			<?php foreach($weekday_offsets as $i=>$o) printf("<option value='%d'>%s</option>", $i, $o) ?>
			</select>
			<select id="to_weekday_name">
			<?php foreach($valid_weekdays as $i=>$d) printf("<option value='%d'>%s</option>", $i, $d) ?>
			</select>
			<select id="to_weekday_month">
				<option value=''>Every month</option>
				<?php foreach($valid_months as $i=>$m) printf("<option value='%d'>%s</option>", $i, $m) ?>
			</select>
		</td>
	</tr>
	<tr class="date_range_rows day_range_rows simple">
		<td class="HelpList" colspan="2">
			<a href="#" title="Click to view help on frequency" tabindex='-1' data-help='exception_frequency'><img src="images/icons/shield-help.png" alt="Help" title="Help" /></a>
		</td>
		<td class="VarList"> Frequency</td>
		<td>
			<input type='text' value='' id='exc_freq' style='width: 50px'/>
		</td>
	</tr>
	<tr class="simple">
		<td class="HelpList" colspan="2">
			<a href="#" title="Click to view help on hours" tabindex='-1' data-help='exception_hours'><img src="images/icons/shield-help.png" alt="Help" title="Help" /></a>
		</td>

		<td class="VarList"><label for="exc_hours">Hours</label></td>
		<td><input type="text" id="exc_hours" value="00:00-24:00" class="large" /></td>
	</tr>
	<tr class="simple">
		<td class="HelpList" colspan="2">
			<a href="#" title="Click to view help on add/save buttons" tabindex='-1' data-help='add_save'><img src="images/icons/shield-help.png" alt="Help" title="Help" /></a>
		</td>
		<td class="VarList">&nbsp;</td>
		<td>
			<input type="button" value="Add" class="button add" id="exc_add_button" title="Add" />
			<input type="button" value="Save" class="button save" id="exc_save_button" style="display: none"/>
			<input type="button" value="Cancel" class="button cancel" id="exc_cancel_button" style="display: none" />
		</td>
	</tr>
	<tr class="simple">
		<td class="HelpList" colspan="2">
			<a href="#" title="Click to view help on added exceptions" tabindex='-1' data-help='added'><img src="images/icons/shield-help.png" alt="Help" title="Help" /></a>
		</td>
		<td class="VarList">
			<label for="exc_added">Added exceptions</label>
		</td>
		<td>
			<select multiple="multiple" id="exc_added" size="6" class="large multiple">
				<?php print $existing_exceptions; ?>
			</select>
		</td>
	</tr>
	<tr class="simple">
		<td class="HelpList" colspan="2">
			<a href="#" title="Click to view help on remove and edit buttons" tabindex='-1' data-help='remove_edit'><img src="images/icons/shield-help.png" alt="Help" title="Help" /></a>
		</td>
		<td>&nbsp;</td>
		<td>
			<input type="button" id="exc_remove_button" value="Remove" class="button remove" title="Remove" />
			<input type="button" id="exc_edit_button" value="Edit" class="button edit" title="Edit" />
		</td>
	</tr>
	<tr style="display: none" class="advanced">
		<td class="HelpList" colspan="2">
			<a href="#" title="Click to view help on advanced" tabindex='-1' data-help='advanced'><img src="images/icons/shield-help.png" alt="Help" title="Help" /></a>
		</td>
		<td>
			<label for="exc_adv">Advanced</label>
		</td>
		<td>
			<textarea name="advanced" id="exc_adv" rows="5" cols="41"></textarea>
		</td>
	</tr>
<?php
}
