<?php

/**
 * A contact group definition is used to group one or more contacts together
 * for the purpose of sending out alert/recovery notifications.
 */
class contactgroup_nacoma_Model extends naemon_nacoma_Model
{
	/** object type */
	const TYPE = 'contactgroup';

	public $properties = array (
		'topic' => 'contactgroup_name',
		'var_index' => array (
			'contactgroup_name' => 'string',
			'alias' => 'string',
			'members' => 'mselect',
			'contactgroup_members' => 'mselect',
			'file_id' => 'select',
			'register' => 'bool'
		),
		'widget' => array (
			'register' => 'hidden'
		),
		'required' => array (
			'contactgroup_name',
			'alias',
			'file_id'
		),
		'default' => array (
			'file_id' => 'etc/contactgroups.cfg'
		),
		'special' => array (
			'members' => 'contact',
			'contactgroup_members' => 'contactgroup',
			'file_id' => 'FILE'
		)
	);

	/**
	 * Return the mayi resource for the object
	 * @see object_nacoma_Model::mayi_resource()
	 */
	public function mayi_resource() {
		return "monitor.monitoring.contactgroups";
	}
}
