<ul class="page-flow-layout">
<?php
	$linkprovider = LinkProvider::factory();
	foreach ($sections as $section) {
		$section = $sitemap[$section];
		printf("<li><h2>%s</h2>", $section['label']);
		if($allowed_edit_host && $section['label'] == 'Hosts and services') {
?>
			<div class="configuration-page-link" style="width: auto; display: block;">
				<form name="host_form" id="host_form" action="<?php echo $linkprovider->get_url('configuration', 'configure') ?>" method="get">
					<input type="hidden" name="type" value="host" />
					<span>Select a host to edit </span>
					<select style="vertical-align: middle" id="name" name="name" data-type="host" data-filterable="true" data-required="true"></select>
					<input type="hidden" value="Go" name="action">
					<input type="submit" title="Go" value="Go">
				</form>
			</div>
<?php
		}
		echo "<ul>";
		foreach ($section['children'] as $type => $link) {

			echo '<li class="configuration-page-link">';

			if (isset($link['href'])) {
				echo sprintf('<a href="%s" title="%s">', call_user_func_array(
					array($linkprovider, 'get_url'), $link['href']
				), $type);
			}

			echo html::icon($link['icon']);
			echo '<span>' . $link['label'];

			if (isset($link['object_type'])) {

				$type = $link['object_type'];
				$changes = Changelog_nacoma_Model::get_type_count($link['object_type']);

				if ($changes > 0) {
					$title = 'You have ';
					if ($changes > 1) $title .= $changes . ' unsaved ' . $type . 's';
					else $title .= 'an unsaved ' . $type;

					echo html::badge('warning', $changes, array(
						"title" => $title
					));
				}

				// @TODO Make edit service usable without providing a host
				// This is a special case until services can be added
				// without going through a host so that users can see
				// changes to services
				if ($type === 'host') {
					$schanges = Changelog_nacoma_Model::get_type_count('service');
					if ($schanges > 0) {
						$title = 'You have ';
						if ($schanges > 1) $title .= $schanges . ' unsaved services';
						else $title .= 'an unsaved service';
						echo html::badge('warning', $schanges . ' service' . (($schanges > 1) ? 's' : ''), array(
							"title" => $title
						));
					}
				} // End of special case

			}

			echo '</span>';

			if (isset($link['description'])) {
				echo '<br /><span class="configuration-page-description">' . html::specialchars($link['description']) . '</span>';
			}

			if (isset($link['href'])) {
				echo '</a>';
			}

			echo '</li>';

		}

		echo '</ul></li>';

	}

?>
</ul>
